/*            AIFCCUT                */
/* O. Hammer,  oyvindha@notam.uio.no */
/*           NoTAM 1995              */

#include <stdio.h>
#include <stdlib.h>
#include <audiofile.h>

main(argc, argv)
int argc;
char **argv;
{
  long framecnt, endframe, compression, filefmt, bits,
    samp_type, vers, frame;
  int sfreq, channels, numtoread;
  AFfilehandle infile, outfile;
  AFfilesetup in_AFsetup, out_AFsetup;
  short int framebuff[8192];

  if (argc!=5) {
    printf("Usage: aifccut <infile> <in time> <out time> <outfile>\n");
    exit(-1);
  }

  in_AFsetup=AFnewfilesetup();
  infile=AFopenfile(argv[1], "r", in_AFsetup);
  if (infile==NULL) {
    printf("Couldn't open input file\n");
    exit(-1);
  }

  channels = AFgetchannels(infile, AF_DEFAULT_TRACK);
  sfreq    = (int)AFgetrate(infile, AF_DEFAULT_TRACK);
  compression       = AFgetcompression(infile, AF_DEFAULT_TRACK);
  filefmt           = AFgetfilefmt(infile, &vers);
  AFgetsampfmt(infile, AF_DEFAULT_TRACK, &samp_type, &bits);
  framecnt          = AFgetframecnt(infile,  AF_DEFAULT_TRACK);

  frame=(long)(atof(argv[2])*sfreq);
  if (AFseekframe(infile, AF_DEFAULT_TRACK,(int)frame)<0) {
    printf("Couldn't start at in time\n");
    AFclosefile(infile);
    exit(-1);  
  }

  endframe=(long)(atof(argv[3])*sfreq);
  if (endframe>framecnt) {
    endframe=framecnt;
    printf("Warning: Out time larger than input file duration, truncating\n");
  }

  out_AFsetup=AFnewfilesetup();
  AFinitchannels(out_AFsetup, AF_DEFAULT_TRACK, channels);
  AFinitrate(out_AFsetup, AF_DEFAULT_TRACK, sfreq);
  AFinitcompression(out_AFsetup, AF_DEFAULT_TRACK, compression);
  AFinitfilefmt(out_AFsetup, filefmt);
  AFinitsampfmt(out_AFsetup, AF_DEFAULT_TRACK, samp_type, bits);
  outfile=AFopenfile(argv[4], "w", out_AFsetup);

  if (outfile==NULL) {
    printf("Couldn't open output file\n");
    AFclosefile(infile);
    exit(-1);
  }

  do {
    numtoread=2048;
    if (frame+numtoread>endframe) numtoread=endframe-frame;
    if  (AFreadframes(infile,AF_DEFAULT_TRACK,framebuff,numtoread)<numtoread) {
      printf("Error when reading input file\n");
      AFclosefile(infile);
      AFclosefile(outfile);
      exit(-1);
    }
    if (AFwriteframes(outfile,AF_DEFAULT_TRACK,framebuff,numtoread)<numtoread) {
      printf("Error when writing output file\n");
      AFclosefile(infile);
      AFclosefile(outfile);
      exit(-1);
    }
    frame+=numtoread;
  } while (numtoread==2048);

  AFclosefile(infile);
  AFclosefile(outfile);

}
